
#include <stdio.h>
#include <allegro.h>

typedef unsigned char uint8;

BITMAP *spr;
PALETTE pal;

uint8 vram[0x1000];


void make_vram(void)
{
    int which;

    for(which = 0; which < 2; which++)
    {
        int i, x, y;
        int row, col;
        int k = 0;
        int offset = (which) ? 8 : 0;

        for(row = 0; row < 8; row++)
        {
            for(col = 0; col < 8; col++)
            {
                for(y = 0; y < 16; y++)
                {
                    uint8 b0 = 0;
                    uint8 b1 = 0;
                    uint8 b2 = 0;
                    uint8 b3 = 0;

                    for(x = 0; x < 8; x++)
                    {
                        int c = getpixel(spr, col*8+x, row*16+y);

                        switch(c)
                        {
                            case 0:
                                    c = 1+offset;
                                    break;
                            case 1:
                                    c = 2+offset;
                                    break;
                            case 2:
                                    c = 0;
                                    break;
                            case 3:
                                    c = 3+offset;
                                    break;
                            case 4:
                                    c = 4+offset;
                                    break;
                            case 5:
                                    c = 5+offset;
                                    break;
                            case 6:
                                    c = 6+offset;
                                    break;
                            case 15:
                                    c = 7+offset;
                                    break;
                        }

                        int i0 = (c >> 0) & 1;
                        int i1 = (c >> 1) & 1;
                        int i2 = (c >> 2) & 1;
                        int i3 = (c >> 3) & 1;

                        b0 |= (i0 << (x ^ 7));
                        b1 |= (i1 << (x ^ 7));
                        b2 |= (i2 << (x ^ 7));
                        b3 |= (i3 << (x ^ 7));
                    }
                    vram[(k*64)+(y*4)+0] = b0;
                    vram[(k*64)+(y*4)+1] = b1;
                    vram[(k*64)+(y*4)+2] = b2;
                    vram[(k*64)+(y*4)+3] = b3;
                }             
                k++;
            }
        }
    
        FILE *fd;
        char fn[128];
        sprintf(fn, "cake%d.vrm", 1+which);
        fd = fopen(fn, "wb");
        fwrite(vram, sizeof(vram), 1, fd);
        fclose(fd);
    }
}

int main (int argc, char *argv[])
{
    allegro_init();

    set_color_depth(8);
    set_gfx_mode(GFX_AUTODETECT_WINDOWED, 512, 384, 0, 0);
    clear(screen);

    spr = load_bmp("cake.bmp", pal);
    if(!spr) 
        exit(1);
    make_vram();
    return 0;
}
END_OF_MAIN();
