;----------------------------------------------------------------------------
; init.inc --
;----------------------------------------------------------------------------

.EMPTYFILL $00
.SMSTAG
.COMPUTESMSCHECKSUM
.MEMORYMAP
        DEFAULTSLOT     0
        SLOTSIZE        $8000
        SLOT            0       $0000
.ENDME

.ROMBANKMAP
        BANKSTOTAL      1
        BANKSIZE        $8000
        BANKS           1
.ENDRO

;------------------------------------------------------------------------------
; Variables
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
.BANK 0 SLOT 0
;------------------------------------------------------------------------------

                        .orga   $0000
                        di
                        im      1
                        jp      __reset

                        .orga   $0008
                        ret

                        .orga   $0010
                        ld      a, l
                        out     ($BF), a
                        ld      a, h
                        out     ($BF), a
                        ret

                        .orga   $0018
                        ld      a, l
                        out     ($BE), a
                        ld      a, h
                        out     ($BE), a
                        ret

                        .orga   $0020
                        ret

                        .orga   $0028
                        ret

                        .orga   $0030
                        ret

                        .orga   $0038
                        ex      af, af'
                        in      a, ($BF)
                        or      a
                        jp      p, line_interrupt
                        jp      frame_interrupt


                        .orga   $0066
                        push    af
                        call    nmi_handler
                        pop     af
                        retn

;------------------------------------------------------------------------------
; Initialization code
;------------------------------------------------------------------------------

__reset:
                        ; Set stack top
                        ld      sp, $DFF0

                        ; Set up memory mapping registers
                        ld      ix, $FFFC
                        ld      (ix+$00), $80
                        ld      (ix+$01), $00
                        ld      (ix+$02), $01
                        ld      (ix+$03), $02

                        ; Clear work RAM
                        ld      hl, $C000
                        ld      de, $C001
                        ld      bc, $1FEF
                        ld      (hl), l
                        ldir

                        ; Initialize hardware
                        call    hw_init

                        jp      main

;----------------------------------------------------------------------------
; Subroutines
;----------------------------------------------------------------------------

hw_init:
                        call    vdp_init
                        call    psg_mute
                        ret

;----------------------------------------------------------------------------
; End
;----------------------------------------------------------------------------
